use CGI;
&ReadParameters();
&ReadCookies();

# miscellaneous
$SORTORDER = $COOKIES{'sortorder'};
($TAKEERRORS_CFG)?($TAKEERRORS = '2>&1'):($TAKEERRORS='');
$PREVIEWIMGSRC = "$HTMLAREAURL/images/su_loading.gif";
$RAND = time;

# skins directory (uses $SKINSSUBDIR from config.pm)
$SKINSDIR = "$SITEUPDIR$DIRSEPARATOR$SKINSSUBDIR";
$SKINSDIR =~ s/(\/|\\)/$DIRSEPARATOR/ge;

# prepare right format document root directory
$DOCUMENT_ROOT = $DOCUMENT_ROOT_DIR;
$DOCUMENT_ROOT =~ s'(/|\\)$'';
$DOCUMENT_ROOT =~ s/(\/|\\)/$DIRSEPARATOR/ge;

# current directory must be less or equal to $DOCUMENT_ROOT
$CURDIR = $P{'dir'};
do{
	my $document_root = $DOCUMENT_ROOT;
	$document_root =~ s/(\\|\$)/\\$1/g;
	$CURDIR = $DOCUMENT_ROOT if (!$CURDIR or !-d "$CURDIR" or ($CURDIR !~ /^$document_root/)) 
};
$CURDIRESCAPED = &EscapeChars($CURDIR);

# upper directory
$UPDIR = $CURDIR;
if ($CURDIR gt $DOCUMENT_ROOT)
{
	$CURDIR =~ /^(.*)(\\|\/)(.*)/;
	$UPDIR = $1;
	$FILEDIR = $3;
}
$UPDIRESCAPED = &EscapeChars($UPDIR);

# pack/unpack
if ($OS eq 'win')
{
	foreach (split(/\n/, $UNPACKWIN))
	{
		split(/\:/,$_,2);
		$_[1]=~s/^ +//;
		$UNPACKWIN{$_[0]}=$_[1];
	};
	$ARCHFILES = join(',', keys(%UNPACKWIN))
	}
else {
	foreach (split(/\n/, $UNPACKNIX))
	{
		split(/\:/,$_,2);
		$_[1]=~s/^ +//;
		$UNPACKNIX{$_[0]}=$_[1];
	};
	$ARCHFILES = join(',', keys(%UNPACKNIX)) 
}

# HTMLArea styles list
if ($MYSTYLESLIST_CFG)
{
		my ($line,$mystyleslist) = ();
		foreach $line(split(/\n/, $MYSTYLESLIST_CFG))
		{
			$line =~ s/\s+//g;
			my($name,$class)=split(/\,/, $line);
			$mystyleslist .= qq{ {name:"$name", className:"$class", classStyle:""}, } if $name and $class;
		};
		$MYSTYLESLIST = $mystyleslist;
};

# load modules and collect errors
eval('use SendMail;'); $sendmailerror = $@;
eval('use Net::FTP;'); $ftperror = $@;
eval('use HTTP::Lite;'); $httperror = $@;
eval('use XML::Simple'); $xmlerror = $@;

# load skins and language
eval(q{
	use ISkins;
	$skin = new ISkins("$SKINSDIR$DIRSEPARATOR");
	$skin->{'templatesext'} = "$SKINSEXT";
	$skin->{'loadinmemory'} = "$SKINSINMEM";
	require "$SKINSDIR$DIRSEPARATOR".'language.pm';
});
$skinerror = $@;
if (!$skinerror) { $skin->LoadTemplates() && ($skinerror .= $skin->{'error'}); }

# random tips and tricks
if ($SHOWTIPS)
{
	local *FILE;
	open FILE, "$SKINSDIR$DIRSEPARATOR".'tipstricks.txt';
	my @tiptexts = <FILE>;
	close FILE;
	$TIPTEXT = $tiptexts[int(rand(@tiptexts))];
}

# descript.ion
&ReadFDescriptions($CURDIR) if ($ENABLEFILEDESCRIPTION);

1;

