#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

sleep 1 if !%P;
print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

print $skin->Template('page_header');
print $skin->Template('page_tips') if $SHOWTIPS;
print $skin->Template('page_attention', $skin->Template('page_upgrades')) if $SiteUpVer ne $CURRENTVER;
print $skin->Template('page_attention', $skin->Template('page_unprotected')) if !$ENV{'REMOTE_USER'} and $SHOWUNAUTHWARN;

require "actions.pm";

($dirdate) = &TextDateTime(&FileInfo($CURDIR));
$qty = 0; $filessize = 0;
opendir (DIR, $CURDIR);
while ($file = readdir(DIR))
{
	(-d "$CURDIR$DIRSEPARATOR$file")
	? do{push (@dirs, join("\0", $file, &FileInfo("$CURDIR$DIRSEPARATOR$file"))) if ($file ne '.' and $file ne '..' and !grep($file eq $_, split(/\,/, "$IGNOREDIRS")))}
	: push (@files, join("\0", $file, &FileInfo("$CURDIR$DIRSEPARATOR$file")))
}
closedir(DIR);
@dirs = &SortFiles(@dirs);
@files = &SortFiles(@files);
$i = 4;
foreach $fileinfo(@dirs, @files)
{
	if (grep($fileinfo =~ /\.$_$/i , split(/\,/, "$IGNOREFILES"))) { next }
	($file, $filedate, $filesize, $fileurl, $filemode, $slink) = split(/\0/, $fileinfo);
	$filessize += $filesize;
	$slink?($slink=$skin->Template('ls_symlink', $slink)):($slink='');
	++$qty;
	if (-d "$CURDIR$DIRSEPARATOR$file")
	{
		$filesize = 'DIR';
		$filename = $skin->Template('ls_dir_found', $file);
	}
	else
	{
		if (grep($file =~ /\.$_$/i, split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = $skin->Template('ls_edit', $file) }
		elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $filename = $skin->Template('ls_archive', $file) }
		elsif (grep($file =~ /\.$_$/i, split(/\,/, "$XMLFILES"))) { $filename = $skin->Template('ls_xml', $file) }
		else { $filename = $file; }
		$filesize = $skin->Template('ls_download', $file, $filesize);
		$filemode = $skin->Template('ls_execute', $file, $filemode) if ($filemode =~ '7');
	}
	if (!$ENABLEFILEDESCRIPTION or !$FDESCRIPTION{$file})
	{
		$files .= $skin->Template('ls_file_found', $i, $file, $fileurl, $filename, $slink, &TextDateTime($filedate), $filemode, $filesize);
	}
	else
	{
		$files .= $skin->Template('ls_file_found_descr', $i, $file, $fileurl, $filename, $slink, &TextDateTime($filedate), $filemode, $filesize, $FDESCRIPTION{$file});
	}
	$i += 2;
}

print $skin->Template('page_section', "$lang{'selected_dir'} $CURDIR");

if ($files) { print $skin->Template('ls_files_found', $files, $filessize, $qty, $dirdate); }
else { print $skin->Template('ls_not_found'); }

print $skin->Template('page_footer');

