#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

print $skin->Template('page_header');
print $skin->Template('page_tips') if $SHOWTIPS;

if ($xmlerror)
{
	print $skin->Template('page_section', qq{$lang{'xml_view_file'} $P{'file'} $lang{'in_directory'} $CURDIR});
	print $skin->Template('page_error', "$lang{'xml_error'} $xmlerror")
}
else
{
	$CONFIG = eval { XMLin("$CURDIR$DIRSEPARATOR$P{'file'}") } || print $skin->Template('page_error', "$lang{'xml_error'} $@");
	$P{'xmlpath'}?($XMLPATH = $P{'xmlpath'}):($XMLPATH = '');
	$P{'query'} = '' if !$P{'query'};
	if (!$P{'query'})
	{
		foreach my $line(split('->', $XMLPATH))
		{
			next if !$line;
			$xmlpath .= "->$line";
			$XMLPATHES .= qq{-><a href="xmlview.cgi?dir=$CURDIR&file=$P{'file'}&xmlpath=$xmlpath">$line</a>}
		}
		print $skin->Template('page_section', qq{$lang{'xml_path'} <a href="xmlview.cgi?dir=$CURDIR&file=$P{'file'}">$P{'file'}</a>$XMLPATHES});
		foreach $section(eval('keys %{$CONFIG'.$XMLPATH.'}'))
		{
			my $ref = ref(eval('$CONFIG'.$XMLPATH."->{$section}"));
			if (!$ref or $ref eq 'HASH')
			{
				$xml_file_content .= $skin->Template('xml_hash', $section, $P{'file'});
			}
			elsif ($ref eq 'ARRAY')
			{
			  for (my $i=0; $i<=$#{eval('$CONFIG'.$XMLPATH."->{$section}")}; ++$i)
				{
					$xml_file_content .= $skin->Template('xml_array', $section, $i, $P{'file'});
				}
			}
		}
		$xml_file_content .= $skin->Template('xml_value', eval('$CONFIG'.$XMLPATH)) if !ref(eval('$CONFIG'.$XMLPATH));
		print $skin->Template('xml_file_content', $xml_file_content);
	}
	else
	{
		print $skin->Template('page_section', qq{$lang{'xml_search_results'} <a href="xmlview.cgi?dir=$CURDIR&file=$P{'file'}">$P{'file'}</a>});
		print $skin->Template('xml_search_results', &SearchXML($P{'query'}, $XMLPATH));
	}
	print $skin->Template('page_section', $lang{'xml_start_search'});
	print $skin->Template('xml_search_form', $P{'file'}, $P{'query'});
}
print $skin->Template('page_footer');

sub SearchXML
{
	my ($query, $xmlpath) = @_;
	my ($result) = ();
	foreach my $section(eval('keys %{$CONFIG'.$xmlpath.'}'))
	{
		my $ref = ref(eval('$CONFIG'.$xmlpath."->{$section}"));
		if (!$ref or $ref eq 'HASH')
		{
			my $qsection = $section;
			$result .= &SearchXML ($query, "$xmlpath\->{$section}");
		}
		elsif ($ref eq 'ARRAY')
		{
		  for (my $i=0; $i<=$#{eval('$CONFIG'.$xmlpath."->{$section}")}; ++$i)
			{
				my $qsection = $section[$i];
				$result .= &SearchXML ($query, "$xmlpath\->{$section}\[$i]");
			}
		}
	}
	my $qsection = eval('$CONFIG'.$xmlpath);
	if (!ref(eval('$CONFIG'.$xmlpath)) and $qsection =~ s/($P{'query'})/"<b>$1<\/b>"/gie)
	{
		my ($xmlpath2, $xmlpathes);
		foreach my $line(split('->', $xmlpath))
		{
			next if !$line;
			$xmlpath2 .= "->$line";
			$xmlpathes .= qq{-><a href="xmlview.cgi?dir=$CURDIR&file=$P{'file'}&xmlpath=$xmlpath2">$line</a>}
		}
		$result .= $skin->Template('xml_search_found', $P{'file'}, $xmlpathes, $qsection);
	}
	return $result
}

