#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

$CURDIR =~ /^(.*)(\\|\/)(.+)$/;
$pagetitle = $3;

$directories .= $skin->Template('menu_goup') if ($DOCUMENT_ROOT ne $CURDIR);

opendir (DIR, $CURDIR);
while ($file = readdir(DIR))
{
	(-d "$CURDIR$DIRSEPARATOR$file")
	? push (@dirs, join("\0", $file, &FileInfo("$CURDIR$DIRSEPARATOR$file")))
	: push (@files, join("\0", $file, &FileInfo("$CURDIR$DIRSEPARATOR$file")))
}
closedir(DIR);
@dirs = &SortFiles(@dirs);
@files = &SortFiles(@files);
foreach $fileinfo(@dirs)
{
	($file) = split(/\0/, $fileinfo);
	next if grep($file eq $_, split(/\,/, "$IGNOREDIRS"));
	$FDESCRIPTION{$file} = '' if !$FDESCRIPTION{$file}; $FDESCRIPTION{$file} =~ s/"/&#34;/g;
	$directories .= $skin->Template('menu_cd', $file, $FDESCRIPTION{$file}) if ($file ne '.' and $file ne '..');
}
foreach $fileinfo(@files)
{
	($file, $filedate, $filesize, $fileurl) = split(/\0/, $fileinfo);
	next if grep($file =~ /\.$_$/i , split(/\,/, "$IGNOREFILES"));
	$FDESCRIPTION{$file} = '' if !$FDESCRIPTION{$file}; $FDESCRIPTION{$file} =~ s/"/&#34;/g;
	if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $directories .= $skin->Template('menu_edit', $file, $filesize, &TextDateTime($filedate), $FDESCRIPTION{$file}) }
	elsif (grep($file =~ /\.$_$/i , split(/\,/, "$IMGFILES"))) { $directories .= $skin->Template('menu_image', $file, $fileurl, $filesize, &TextDateTime($filedate), $FDESCRIPTION{$file}) }
	elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $directories .= $skin->Template('menu_archive', $file, $filesize, &TextDateTime($filedate), $FDESCRIPTION{$file}) }
	elsif (grep($file =~ /\.$_$/i, split(/\,/, "$XMLFILES"))) { $directories .= $skin->Template('menu_xml', $file, $filesize, &TextDateTime($filedate), $FDESCRIPTION{$file}) }
	else { $directories .= $skin->Template('menu_file', $file, $filesize, &TextDateTime($filedate), $FDESCRIPTION{$file}) }
}

print $skin->Template('menu_page', $pagetitle, $directories);

